<?php
/*
  NPC mySQL Import

  Parses UTF-16 NPCDATA into ISO-8859-1 strings
  which can then be stored into mysql for easier
  minipulation through scripts.

  RELEASED UNDER THE TERMS OF GPL
  RELEASED BY ISOGAMES.COM
  AUTHOR :: FIREDAEMON
*/

set_time_limit(0);

/*
set to read only to not store in database and simply test the parsing
Will generate a list of unique data in the npc script
*/
$readonly = false;

$link = @mysql_connect("host", "user", "password");

($link) ? $dbselect = @mysql_select_db("l2scripts") : DIE("Link to mySQL server could not be established.");

$file_loc = "/path/to/my/npcdata.txt";

($dbselect) ? $npc = file($file_loc) : DIE(mysql_error());

echo "<pre>";
echo "NPC Data Lines: ".count($npc)."\n";

$fieldData = array();

for ($i=0; $i<count($npc); $i++)
{
   $npc[$i] = iconv("UTF-16", "ISO-8859-1", $npc[$i]);

   $data = split("\t", $npc[$i]);

   $fieldIns="";
   $fieldTracker = array();
   $fieldOffset = 2;

   for ($d=0; $d<count($data); $d++)
   {
      if (strstr($data[$d], "npc_begin") || strstr($data[$d], "npc_end"))
      {
         $field = false;
      }
      elseif (is_numeric($data[$d]))
      {
         $field[0] = 'id';
         $field[1] = $data[$d];
         $iid = $data[$d];
      }
      elseif (strstr($data[$d], "="))
      {
         $field = explode("=", trim($data[$d]), 2);
      }
      elseif (strstr($data[$d], "["))
      {
         $field = array('title', trim($data[$d]));
      }
      elseif (strlen($data[$d]))
      {
         $field = array('class', trim($data[$d]));
      }
      else
      {
         print "Empty data detected.\n\n";
      }

      if ($field)
      {
         if (!isset($fieldTracker["_".md5($field[0])]))
         {
            if (is_numeric($field[1])) $field[1] = floatval($field[1]);

            $_md5[$i][$field[0]] = md5($field[1]);

            $fieldTracker["_".md5($field[0])] = true;

            $fieldIns.= "`".$field[0]."`"."='".addslashes($field[1])."'";

            ($d<(count($data)-$fieldOffset)) ? $fieldIns.= ",\n" : $fieldIns.="\n";

            $fieldData[$field[0]]['_'.md5($field[1])] = $field[1];
         }
         elseif ($field[0] == "id")
         {//file read error
            print "== FILE READ ERROR ==\n";
            var_dump($field);
            print "\n";
            var_dump($npc[$i]);
            print "\n";
            DIE("Duplicate data line error ID#".$iid);
         }
      }
   }

   if (!$readonly && strlen($fieldIns))
   {
      $npcquery = "
               INSERT INTO
                   npcdata
               SET
               ";

      $npcquery.= $fieldIns;

      mysql_query($npcquery);

      if (mysql_affected_rows())
      {
         $dbresquery = "
                  SELECT
                   *
                  FROM
                   npcdata
                  WHERE
                   id='".$iid."'
                  ";

         $result = mysql_query($dbresquery);
         $sql_npc = mysql_fetch_array($result);

         while (list($key, $value) = each($_md5[$i]))
         {
            if (is_numeric($sql_npc[$key])) $sql_npc[$key] = floatval($sql_npc[$key]);

            if ($_md5[$i][$key] != md5(stripslashes($sql_npc[$key])))
            {
               print "== MYSQL ERROR ==\n";
               print mysql_error()."\n\n";

               $query = "TRUNCATE npcdata";
               mysql_query($query);

               print "== NPC QUERY ==\n";
               var_dump($npcquery);
               print "\n\n";

               print "== DB RESULT QUERY ==\n";
               print $dbresquery."\n\n";
               var_dump($sql_npc);
               print "\n\n";

               print "== NPC TEXT ==\n";
               print $npc[$i]."\n\n";

               DIE("Criticle Error. NPC Data Mis Match with key:".$key." having a value of ".$sql_npc[$key]."\n\n");
            }
         }

         print "Successfully added NPC Data #".$iid."\n";
      }
      else
      {
         $query = "DELETE FROM npcdata";
         mysql_query($query);
         print $npcquery;
         DIE("NPC mySQL record was not added. Terminating insert. " . mysql_error());
      }
   }

   ob_flush();

}

print "== UNIQUE FIELD DATA ==\n";
var_dump($fieldData);
print "\n\n";

echo "</pre>";

?>
